<?php

namespace Oro\Bundle\AbandonedCartBundle\Tests\Unit\Form\Type;

use Oro\Bundle\AbandonedCartBundle\Form\Type\AbandonedCartConversionType;
use Oro\Bundle\AbandonedCartBundle\Model\AbandonedCartList\AbandonedCartConversionManager;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AbandonedCartConversionTypeTest extends \PHPUnit\Framework\TestCase
{
    /**
     * @var AbandonedCartConversionType
     */
    protected $abandonedCartConversionType;

    /**
     * @var \PHPUnit\Framework\MockObject\MockObject|AbandonedCartConversionManager
     */
    protected $conversionManager;

    /**
     * @var string
     */
    protected $mailChimpCampaignClassName;

    protected function setUp()
    {
        $this->conversionManager = $this->getMockBuilder(
            'Oro\Bundle\AbandonedCartBundle\Model\AbandonedCartList\AbandonedCartConversionManager'
        )
            ->disableOriginalConstructor()
            ->getMock();
        $this->mailChimpCampaignClassName = 'ClassName';
        $this->abandonedCartConversionType = new AbandonedCartConversionType(
            $this->conversionManager,
            $this->mailChimpCampaignClassName
        );
    }

    public function testConfigureOptions()
    {
        /** @var \PHPUnit\Framework\MockObject\MockObject|OptionsResolver $resolver */
        $resolver = $this->createMock('Symfony\Component\OptionsResolver\OptionsResolver');

        $resolver->expects($this->once())
            ->method('setDefaults')
            ->with(
                ['data_class' => 'Oro\Bundle\AbandonedCartBundle\Entity\AbandonedCartConversion']
            );

        $this->abandonedCartConversionType->configureOptions($resolver);
    }
}
